#include <curses.h>
#include "consts.h"

#define PAIR_COUNT (sizeof(PairsList) / sizeof(PairsList[0]))
#define PR_CNT2ID(pair) ((pair) + 1)

extern char *malloc();

int GreenBlackPair;
int RedBlackPair;
static int ColdPair;

typedef struct pairs_t {
	unsigned long fg;
	unsigned long bg;
	} pairs_t;

static pairs_t PairsList[] = {
	{COLOR_BLACK, COLOR_YELLOW},
	{COLOR_BLACK, COLOR_RED},
	{COLOR_BLACK, COLOR_MAGENTA}};

void ColorMapInit()

	{
	int i;
	int id;

	for (i = 0; i < PAIR_COUNT; ++i)
		{
		id = PR_CNT2ID(i);
		if (init_pair(id, PairsList[i].fg, PairsList[i].bg) != OK)
			{
			endwin();
			fprintf(stderr, "init_pair: %d failed\n", id);
			exit(0);
			}
		}
	GreenBlackPair = PR_CNT2ID(PAIR_COUNT);
	if (init_pair(GreenBlackPair, COLOR_GREEN, COLOR_BLACK) != OK)
		{
		endwin();
		fprintf(stderr, "init_pair: %d failed\n", GreenBlackPair);
		exit(0);
		}
	ColdPair = PR_CNT2ID(PAIR_COUNT + 1);
	if (init_pair(ColdPair, COLOR_BLACK, COLOR_CYAN) != OK)
		{
		endwin();
		fprintf(stderr, "init_pair: %d failed\n", ColdPair);
		exit(0);
		}
	RedBlackPair = PR_CNT2ID(PAIR_COUNT + 2);
	if (init_pair(RedBlackPair, COLOR_RED, COLOR_BLACK) != OK)
		{
		endwin();
		fprintf(stderr, "init_pair: %d failed\n", RedBlackPair);
		exit(0);
		}
	}

int FillColor(win, scale, y, x, field)

WINDOW *win;
double scale;
int y, x;
int field;

	{
	int pair;
	int pair_id;

	if (field == FIELD_HOT)
		{
		pair = scale * (double)PAIR_COUNT;
		if (pair >= PAIR_COUNT)
			pair = PAIR_COUNT - 1;
		else
			if (pair < 0)
				pair = 0;
		pair_id = PR_CNT2ID(pair);
		}
	else
		pair_id = ColdPair;

	wattron(win, COLOR_PAIR(pair_id));
	mvwaddch(win, y, x, ' ');
	wattroff(win, COLOR_PAIR(pair_id));
	}
